<template>
  <div class="container">
    <div class="heading-container items-center justify-between">
      <p class="heading text-xl font-semibold">Record</p>
      <div class="scale-110 flex gap-x-1">
        <RecordSettings
          v-if="!isVideoRecording"
          ref="recordSettingsRef"
          v-model:properties="properties"
          @re-initialize-recorder="initRecorder(properties)"
        />
        <VideoRecordSettings
          v-else
          :before-start="videoRecordingBeforeStart"
          :record-duration="videoRecordingRecordDuration"
          @update-settings="updateVideoSettings"
        ></VideoRecordSettings>
        <KeyboardShortcutsDialog :shortcuts="keyboardShortcuts" />
      </div>
    </div>
    <div class="main-content">
      <div class="words-display">
        <div class="word-list col-span-5 md:col-span-2">
          <ItemList
            :words="store.items"
            :selected-index="currentWord"
            @update-current-word="updateCurrentWord"
          >
            <template #word-status="statusProps">
              <div class="flex gap-x-2">
                <CdxIcon
                  v-if="statusProps.word.id in store.recordings"
                  :icon="cdxIconCheck"
                  aria-label="recorded"
                  class="cursor-pointer scale-75"
                />
              </div>
            </template>
            <template #word-actions="actionProps">
              <div v-if="actionProps.word.id in store.recordings" class="gap-x-1 flex">
                <div v-if="!isVideoRecording" class="bg-white rounded-full p-[1px]">
                  <CdxIcon
                    :icon="cdxIconPlay"
                    aria-label="recorded"
                    class="scale-[0.6] cursor-pointer"
                    @click="playRecording(actionProps.word.id)"
                  />
                </div>
                <div class="bg-white rounded-full p-[1px]">
                  <CdxIcon
                    :icon="cdxIconReload"
                    aria-label="recorded"
                    class="scale-[0.6] -scale-x-[0.6] cursor-pointer"
                    @click="deleteRecording(actionProps.word.id)"
                  />
                </div>
              </div>
            </template>
          </ItemList>
        </div>
        <div class="w-full order-first md:order-last col-span-5 md:col-span-3">
          <div class="recorder-div md:px-10 px-3 py-7 md:py-10">
            <p>
              Click the <span style="color: #36c; font-weight: 500">toggle</span> button to start
              recording
            </p>
            <div
              class="word-recording flex-col justify-center min-h-[150px] sm:min-h-[180px] md:min-h-[250px] py-4"
            >
              <div class="flex-grow flex flex-col items-center justify-center">
                <p class="font-semibold text-center text-lg sm:text-xl md:text-2xl">
                  {{ store.items[currentWord] && store.items[currentWord].displayAs }}
                </p>
                <div>
                  <VideoRecorder
                    v-if="isVideoRecording"
                    ref="videoRecorder"
                    :before-start="videoRecordingBeforeStart"
                    :record-duration="videoRecordingRecordDuration"
                    @ready="handleReady"
                    @started="handleStarted"
                    @stopped="handleStopped"
                    @canceled="handleCanceled"
                  />
                </div>
              </div>
              <CdxButton weight="quiet" class="skip-btn self-end" @click="currentWord++">
                Skip to the next word
                <CdxIcon :icon="cdxIconArrowNext" />
              </CdxButton>
            </div>
          </div>
          <div
            id="recordwizard-actions"
            class="mt-4 flex-col gap-y-6 pt-8 pb-2 px-4 md:py-6 md:px-10"
          >
            <CdxButton
              class="recording-btn"
              @click="isVideoRecording ? toggleVideoRecording() : toggleRecording()"
            >
              <span v-if="!isRecording">Start recording</span>
              <span v-else>Stop recording</span>
            </CdxButton>
            <div class="flex gap-x-1">
              <div id="recordwizard-recorder-indicator">
                <SoundMeter :level="soundLevel" :saturated="isSaturated" />
                <span v-if="isSaturated">SAT</span>
              </div>
              <div id="recordwizard-counter">
                {{ Object.keys(store.recordings).length }} / {{ store.items.length }}
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script setup>
import { LinguaRecorder } from 'lingua-recorder'
import { CdxButton, CdxIcon } from '@wikimedia/codex'
import { cdxIconCheck, cdxIconArrowNext, cdxIconPlay, cdxIconReload } from '@wikimedia/codex-icons'
import { useRecordWizardStore } from '@/stores/recordwizard'
import { ref, onMounted, onUnmounted, watch, defineExpose } from 'vue'
import ItemList from '@/components/ItemList.vue'
import KeyboardShortcutsDialog from '@/components/KeyboardShortcutsDialog.vue'
import RecordSettings from '@/components/RecordSettings.vue'
import VideoRecordSettings from '@/components/VideoRecordSettings.vue'
import SoundMeter from '@/components/SoundMeter.vue'
import { signLanguages } from '../utils/data'
import VideoRecorder from '@/components/VideoRecorder.vue'

const emit = defineEmits(['canGoToNextStep', 'canNotGoToNextStep'])
const recordSettingsRef = ref(null)
const videoRecorder = ref(null)

const handleRecordingTypeChange = (type) => {
  recordSettingsRef.value.handleRecordingTypeChange(type)
}

const toggleVideoRecording = () => {
  isRecording.value ? cancelVideoRecording() : startVideoRecording()
}

const startVideoRecording = () => {
  isRecording.value = true
  videoRecorder.value.start()
}

const stopVideoRecording = () => {
  videoRecorder.value.stop()
  isRecording.value = false
}

const cancelVideoRecording = () => {
  videoRecorder.value.cancel()
  isRecording.value = false
}

const handleReady = (stream) => {
  console.log('Ready:', stream)
}

const handleStarted = () => {
  let time = 1
  const intervalId = setInterval(
    () => {
      soundLevel.value = time
      time += 1
    },
    (videoRecordingRecordDuration.value * 1000) / 15,
  )

  setTimeout(() => {
    clearInterval(intervalId)
  }, videoRecordingRecordDuration.value * 1000)
}

const handleStopped = (videoBlob) => {
  console.log('Recording stopped, videoBlob:', videoBlob)
  isRecording.value = false
  store.items[currentWord.value] && (store.recordings[store.items[currentWord.value].id] = videoBlob)
  currentWord.value += 1
  currentWord.value < store.items.length && startVideoRecording()
}

const handleCanceled = () => {
  console.log('Recording canceled')
}

const playRecording = (word) => {
  console.log(store.recordings)
  if (!store.recordings[word]) return
  const url = URL.createObjectURL(store.recordings[word])
  new Audio(url).play()
}

const deleteRecording = (word) => {
  delete store.recordings[word]
}

const store = useRecordWizardStore()

const isVideoRecording = Object.values(signLanguages).includes(store.selectedLanguageId)
const videoPlayer = ref(null)
const videoBlob = ref(null)

const displayVideo = () => {
  if (videoBlob.value) {
    const videoUrl = URL.createObjectURL(videoBlob.value)
    videoPlayer.value.src = videoUrl
  }
}
const currentWord = ref(0)
const updateCurrentWord = (newWord) => {
  currentWord.value = newWord
}

const isSaturated = ref(false)
const isRecording = ref(false)
const soundLevel = ref(0)

const keyboardShortcuts = [
  {
    key: '←',
    description: 'Previous Word',
  },
  {
    key: '→',
    description: 'Next Word',
  },
  {
    key: 'space',
    long: true,
    description: 'Toggle Recording',
  },
  {
    key: 'p',
    description: 'Play Recording',
  },
  {
    key: 'del',
    description: 'Delete Recording',
  },
]

watch(
  () => store.hasRecordings,
  () => {
    if (store.hasRecordings) emit('canGoToNextStep')
    else emit('canNotGoToNextStep')
  },
)

let recorder // either instance of LinguaRecorder or undefined (reinstanciating allows to reask for permission)
const properties = ref({
  startThreshold: 0.1,
  stopThreshold: 0.05,
  stopDuration: 0.3,
  marginBefore: 0.25,
  marginAfter: 0.25,
  saturationThreshold: 0.99,
})

const videoRecordingBeforeStart = ref(5)
const videoRecordingRecordDuration = ref(3)

const updateVideoSettings = (value, type) => {
  console.log(value, type)
  console.log('Updating video record settings')
  if (type === 'beforeStart') videoRecordingBeforeStart.value = value
  else if (type === 'recordDuration') videoRecordingRecordDuration.value = value
}

const initRecorder = function (properties) {
  recorder = new LinguaRecorder({
    autoStart: true,
    autoStop: true,
    onSaturate: 'discard',
    ...properties,
  })

  recorder.on('ready', () => {
    /* TODO Video recording */
  })
  recorder.on('stopped', (record) => {
    const word = store.items[currentWord.value]
    const blob = record.getBlob()

    store.recordings[word.id] = blob

    if (!moveForward()) {
      cancelRecording()
    }
  })
  recorder.on('canceled', (reason) => {
    isRecording.value = false
    if (reason === 'saturated') {
      startRecording()
    }
  })
  recorder.on('saturated', () => {
    isSaturated.value = true
  })
  recorder.on('recording', (samples) => {
    onDataAvailable(samples)
  })
}

initRecorder(properties.value)

const _move = (displacement) => {
  if (
    currentWord.value + displacement < 0 ||
    currentWord.value + displacement >= store.items.length
  )
    return false

  let wasRecording = false
  if (isRecording.value) {
    cancelRecording()
    wasRecording = true
  }

  currentWord.value += displacement

  if (wasRecording) startRecording()

  return true
}

const moveForward = () => _move(+1)
const moveBackward = () => _move(-1)

const startRecording = function () {
  if (!isRecording.value) {
    if (currentWord.value < 0 || currentWord.value >= store.items.length) {
      return
    }

    handleRecordingTypeChange(store.items[currentWord.value].type)
    console.log(properties.value)
    isRecording.value = true
    isSaturated.value = false
    recorder.start()
  }
}

const cancelRecording = function () {
  if (isRecording.value) {
    recorder.cancel()
    isRecording.value = false
    isSaturated.value = false
    soundLevel.value = false
  }
}

const toggleRecording = function () {
  if (isRecording.value) cancelRecording()
  else startRecording()
}

function onDataAvailable(samples) {
  let amplitude,
    amplitudeMax = 0

  for (const sample of samples) {
    amplitude = Math.abs(sample)
    if (amplitude > amplitudeMax) {
      amplitudeMax = amplitude
    }
  }

  // Display the amplitude on the sound amplitude meter following a parabolic transfer function v(x) = -p*x^2 + (p+15)*x
  // with a factor p=10

  soundLevel.value = Math.floor(-10 * amplitudeMax * amplitudeMax + 25 * amplitudeMax)
  // if we want a linear vumeter: Math.floor( amplitudeMax * 15 );
}

function handleShortcuts(event) {
  // Do not trigger those events when the user is focusing an input
  if (event.target.nodeName === 'INPUT' || event.target.nodeName === 'BUTTON') {
    return
  }

  switch (event.which) {
    case 37: // left
    case 38: // up
      moveBackward()
      break

    case 39: // right
    case 40: // down
      moveForward()
      break

    case 80:
      playRecording(store.items[currentWord.value])
      break

    case 46:
      deleteRecording(store.items[currentWord.value])

    case 32: // space bar
      if (!event.repeat) toggleRecording() // Prevent 'repeating' this action if key is pressed for a long time
      break

    default:
      return
  }
  event.preventDefault()
}

onMounted(() => {
  addEventListener('keydown', handleShortcuts)
})

onUnmounted(() => {
  removeEventListener('keydown', handleShortcuts)
})
</script>

<style scoped>
.container {
  border-radius: 12px;
  box-shadow: 0 8px 20px 0 rgba(0, 0, 0, 0.17);
  width: 100%;
  margin-bottom: 16px;
}

.heading-container {
  padding: 24px 32px;
  border-bottom: 1px solid #dadada;
  display: flex;
  gap: 8px;
}

.words-display {
  display: grid;
  grid-template-columns: repeat(5, minmax(0, 1fr));
}

.word-list {
  padding: 4px;
  padding-right: 2px;
}

div.word-list {
  border-right: 1px solid #dadada;
}

.recorder-div {
  padding-bottom: 32px;
  width: 100%;
  position: relative;
}

.recorder-div > p {
  text-align: center;
  font-weight: 300;
  font-size: 18px;
}

.word-recording {
  margin-top: 24px;
  background-color: #f8f9fa;
  display: flex;
  justify-content: center;
}

.skip-btn {
  background: none;
  border: none;
  color: #a2a9b1;
  font-weight: bold;
  font-size: 16px;
  display: flex;
  align-items: center;
  gap: 8px;
}

#recordwizard-actions {
  display: flex;
  justify-content: space-between;
  align-items: center;
  border-top: 1px solid #dadada;
}

.recording-btn {
  background: #36c;
  border: none;
  color: white;
  padding: 8px 16px;
  border-radius: 8px;
  font-size: 16px;
}
</style>
